
#ifndef BackgroundGrid_H_INCLUDED
#define BackgroundGrid_H_INCLUDED

#pragma once

#include "RenderableElement.h"
#include "GeometryData.h"

#include <string>

struct BackgroundGridData: GeometryData {

	unsigned int m_GridX;
	unsigned int m_GridY;

	BackgroundGridData();
	~BackgroundGridData();

	void SetGrid(unsigned int x, unsigned int y) {
		m_GridX = x;
		m_GridY = y;
		UnloadData();
	}

	virtual void ReloadData(const D3DRenderDevice &device);

	virtual void Render(const D3DRenderDevice &device, const Scene &scene);
};

struct BackgroundGrid: RenderableElement {

	BackgroundGridData data;

	void SetGrid(unsigned int x, unsigned int y) {
		data.SetGrid(x, y);
	}

	virtual void Render(const D3DRenderDevice &device, const Scene &scene);
};

#endif
