
#ifndef FileGeometryData_H_INCLUDED
#define FileGeometryData_H_INCLUDED

#pragma once

#include "RenderableElement.h"
#include "GeometryData.h"

#include <string>

struct FileGeometryData: GeometryData {
	struct FILEVERTPOS;
	struct FILEVERTEX;
	struct FILEFACE;
	struct FILEMATERIAL;

	std::string m_FName;

	unsigned int m_NumVertPos;
	unsigned int m_NumVertices;
	unsigned int m_NumPrimitives;
	unsigned int m_NumMaterials;

	FILEVERTPOS *	m_VertPosList;
	FILEVERTEX *	m_VertexList;
	FILEFACE *		m_FaceList;
	FILEMATERIAL *	m_MaterialList;

	D3DXVECTOR3 *	m_DrawVertPosWaveList;
	D3DXCOLOR *		m_DrawVertPosFogList;
	bool *			m_DrawVertPosList;
	unsigned int *	m_DrawVertexList;
	unsigned int *	m_DrawFaceList;
	unsigned int *	m_DrawMatVertexList;
	unsigned int *	m_DrawMatFaceList;

	FileGeometryData(const std::string &fname);
	~FileGeometryData();

	virtual void ReloadData(const D3DRenderDevice &device);

	virtual void Render(const D3DRenderDevice &device, const Scene &scene);
};

struct File: RenderableElement {

	virtual void Render(const D3DRenderDevice &device, const Scene &scene);
};

#endif
