
#ifndef RenderableElement_H_INCLUDED
#define RenderableElement_H_INCLUDED

#pragma once

#include <vector>

class D3DRenderDevice;
class Scene;

class RenderableElement {
public:
	virtual ~RenderableElement() {}
	virtual void Render(const D3DRenderDevice &device, const Scene &scene) = 0;
};

class RenderableGroup: public RenderableElement {

	std::vector<RenderableElement*>	m_TextList;

public:
	void Add(RenderableElement *element) {
		m_TextList.push_back(element);
	}

	virtual void Render(const D3DRenderDevice &device, const Scene &scene);
};

#endif
