
#ifndef Scene_H_INCLUDED
#define Scene_H_INCLUDED

#pragma once

#include "D3DDevice.h"

#include <vector>

class RenderableElement;
class FogVolumeDistance;
class FogVolume;

class Scene {
public:
	float fov;
	float zNear;
	float zFar;

	D3DXVECTOR3	cameraPos;
	D3DXVECTOR3	cameraLookAt;

	bool		clear;
	D3DCOLOR	clearColor;

	bool		clearZBuf;
	bool		clearStencil;

	FogVolumeDistance *	distanceFog;
	FogVolume **		volFogList;
	unsigned int		numVolFog;

	float animTime;

	RenderableElement *scene;

	ID3DXMatrixStack *matrixStack;

	D3DXMATRIX projectionMatrix;
	D3DXMATRIX projectionMatrixInverse;
	D3DXMATRIX viewMatrix;
	D3DXMATRIX viewMatrixInverse;
	D3DXMATRIX viewprojMatrix;
	D3DXMATRIX viewprojMatrixInverse;

	D3DXVECTOR3	frustumMinVals;
	D3DXVECTOR3	frustumMaxVals;

	virtual void Render(const D3DRenderDevice &device);

	virtual LRESULT WndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam, bool &callDefWndProc) {
		callDefWndProc = true;
		return 0;
	}

	Scene():
		fov			(.8F),
		zNear		(.1F),
		zFar		(100.F),
		cameraPos	(0.F, 1.F, -5.F),
		cameraLookAt(0.F, 0.F, 0.F),
		clear		(true),
		clearColor	(D3DCOLOR_XRGB(0x80, 0x80, 0x00)),
		clearZBuf	(true),
		clearStencil(false),
		distanceFog	(0),
		volFogList	(0),
		numVolFog	(0),
		scene		(0)
	{
	}

	~Scene() {
	}
};

#endif
